Index: issm/trunk/src/c/Makefile.am
===================================================================
--- issm/trunk/src/c/Makefile.am	(revision 464)
+++ issm/trunk/src/c/Makefile.am	(revision 465)
@@ -79,4 +79,5 @@
 					./shared/Dofs/dofs.h\
 					./shared/Dofs/dofsetgen.cpp\
+					./shared/Dofs/DistributeNumDofs.cpp\
 					./shared/Numerics/numerics.h\
 					./shared/Numerics/GaussPoints.h\
@@ -86,251 +87,4 @@
 					./shared/Numerics/BrentSearch.cpp\
 					./shared/Numerics/OptFunc.cpp\
-					./shared/Numerics/extrema.cpp\
-					./shared/Numerics/DistributeNumDofs.cpp\
-					./shared/Exceptions/exceptions.h\
-					./shared/Exceptions/Exceptions.cpp\
-					./shared/Exceptions/exprintf.cpp\
-					./shared/Exp/exp.h\
-					./shared/Exp/IsInPoly.cpp\
-					./shared/Exp/IsInPolySerial.cpp\
-					./shared/Exp/DomainOutlineRead.cpp\
-					./shared/TriMesh/trimesh.h\
-					./shared/TriMesh/AssociateSegmentToElement.cpp\
-					./shared/TriMesh/GridInsideHole.cpp\
-					./shared/TriMesh/OrderSegments.cpp\
-					./shared/TriMesh/SplitMeshForRifts.cpp\
-					./shared/TriMesh/TriMeshUtils.cpp\
-					./shared/Sorting/binary_search.cpp\
-					./shared/Sorting/sorting.h\
-					./shared/Elements/elements.h\
-					./shared/Elements/ResolvePointers.cpp\
-					./shared/Elements/Paterson.cpp\
-					./shared/Elements/GetElementNodeData.cpp\
-					./toolkits/petsc\
-					./toolkits/petsc/patches\
-					./toolkits/petsc/patches/petscpatches.h\
-					./toolkits/petsc/patches/MatlabMatrixToPetscMatrix.cpp\
-					./toolkits/petsc/patches/MatlabVectorToPetscVector.cpp\
-					./toolkits/petsc/patches/PetscMatrixToMatlabMatrix.cpp\
-					./toolkits/petsc/patches/PetscVectorToMatlabVector.cpp\
-					./toolkits/petsc/patches/MatlabMatrixToDoubleMatrix.cpp\
-					./toolkits/petsc/patches/MatlabVectorToDoubleVector.cpp\
-					./toolkits/petsc/patches/PetscDetermineLocalSize.cpp\
-					./toolkits/petsc/patches/VecTranspose.cpp\
-					./toolkits/petsc/patches/VecToMPISerial.cpp\
-					./toolkits/petsc/patches/MatToSerial.cpp\
-					./toolkits/petsc/patches/VecMerge.cpp\
-					./toolkits/petsc/patches/NewVec.cpp\
-					./toolkits/petsc/patches/NewVecFromLocalSize.cpp\
-					./toolkits/petsc/patches/PetscOptionsDetermineSolverType.cpp\
-					./toolkits/petsc/patches/PetscOptionsInsertMultipleString.cpp\
-					./toolkits/petsc/patches/NewMat.cpp\
-					./toolkits/petsc/patches/VecFree.cpp\
-					./toolkits/petsc/patches/VecDuplicatePatch.cpp\
-					./toolkits/petsc/patches/KSPFree.cpp\
-					./toolkits/petsc/patches/ISFree.cpp\
-					./toolkits/petsc/patches/MatFree.cpp\
-					./toolkits/petsc/patches/GetOwnershipBoundariesFromRange.cpp\
-					./toolkits/petsc/patches/VecPartition.cpp\
-					./toolkits/petsc/patches/MatPartition.cpp\
-					./toolkits/petsc/patches/MatInvert.cpp\
-					./toolkits/petsc/patches/MatMultPatch.cpp\
-					./toolkits/petsc/petscincludes.h\
-					./toolkits/mpi/mpiincludes.h\
-					./toolkits/mpi/patches/mpipatches.h\
-					./toolkits/mpi/patches/MPI_Upperrow.cpp\
-					./toolkits/mpi/patches/MPI_Lowerrow.cpp\
-					./toolkits/mpi/patches/MPI_Boundariesfromrange.cpp\
-					./toolkits/metis/metisincludes.h\
-					./toolkits/triangle/triangleincludes.h\
-					./toolkits.h\
-					./io/io.h\
-					./io/FetchData.cpp\
-					./io/WriteData.cpp\
-					./io/WriteDataToDisk.cpp\
-					./io/SerialFetchData.cpp\
-					./io/SerialWriteData.cpp\
-					./io/ParallelFetchData.cpp\
-					./io/ParallelFetchInteger.cpp\
-					./io/ParallelFetchMat.cpp\
-					./io/ParallelFetchScalar.cpp\
-					./io/ParallelFetchString.cpp\
-					./io/ModelFetchData.cpp\
-					./io/WriteNodeSets.cpp\
-					./io/WriteParams.cpp\
-					./io/FetchNodeSets.cpp\
-					./io/FetchRifts.cpp\
-					./io/ParameterInputsInit.cpp\
-					./EnumDefinitions/EnumDefinitions.h\
-					./EnumDefinitions/EnumDefinitions.cpp\
-					./EnumDefinitions/AnalysisTypeAsEnum.cpp\
-					./ModelProcessorx/Model.h\
-					./ModelProcessorx/Model.cpp\
-					./ModelProcessorx/CreateElementsNodesAndMaterials.cpp\
-					./ModelProcessorx/CreateConstraints.cpp \
-					./ModelProcessorx/CreateLoads.cpp\
-					./ModelProcessorx/CreateParameters.cpp\
-					./ModelProcessorx/DiagnosticHoriz/CreateElementsNodesAndMaterialsDiagnosticHoriz.cpp\
-					./ModelProcessorx/DiagnosticHoriz/CreateConstraintsDiagnosticHoriz.cpp \
-					./ModelProcessorx/DiagnosticHoriz/CreateLoadsDiagnosticHoriz.cpp\
-					./ModelProcessorx/DiagnosticHoriz/CreateParametersDiagnosticHoriz.cpp\
-					./ModelProcessorx/DiagnosticVert/CreateElementsNodesAndMaterialsDiagnosticVert.cpp\
-					./ModelProcessorx/DiagnosticVert/CreateConstraintsDiagnosticVert.cpp \
-					./ModelProcessorx/DiagnosticVert/CreateLoadsDiagnosticVert.cpp\
-					./ModelProcessorx/DiagnosticHutter/CreateElementsNodesAndMaterialsDiagnosticHutter.cpp\
-					./ModelProcessorx/DiagnosticHutter/CreateConstraintsDiagnosticHutter.cpp \
-					./ModelProcessorx/DiagnosticHutter/CreateLoadsDiagnosticHutter.cpp\
-					./ModelProcessorx/DiagnosticStokes/CreateElementsNodesAndMaterialsDiagnosticStokes.cpp\
-					./ModelProcessorx/DiagnosticStokes/CreateConstraintsDiagnosticStokes.cpp \
-					./ModelProcessorx/DiagnosticStokes/CreateLoadsDiagnosticStokes.cpp\
-					./ModelProcessorx/SlopeCompute/CreateElementsNodesAndMaterialsSlopeCompute.cpp\
-					./ModelProcessorx/SlopeCompute/CreateConstraintsSlopeCompute.cpp \
-					./ModelProcessorx/SlopeCompute/CreateLoadsSlopeCompute.cpp\
-					./ModelProcessorx/Control/CreateParametersControl.cpp\
-					./Dofx/Dofx.h\
-					./Dofx/Dofx.cpp\
-					./Dux/Dux.h\
-					./Dux/Dux.cpp\
-					./GriddataMeshToGridx/GriddataMeshToGridx.h\
-					./GriddataMeshToGridx/GriddataMeshToGridx.cpp\
-					./ControlConstrainx/ControlConstrainx.h\
-					./ControlConstrainx/ControlConstrainx.cpp\
-					./Misfitx/Misfitx.h\
-					./Misfitx/Misfitx.cpp\
-					./Orthx/Orthx.h\
-					./Orthx/Orthx.cpp\
-					./Gradjx/Gradjx.h\
-					./Gradjx/Gradjx.cpp\
-					./UpdateFromInputsx/UpdateFromInputsx.h\
-					./UpdateFromInputsx/UpdateFromInputsx.cpp\
-					./ConfigureObjectsx/ConfigureObjectsx.h\
-					./ConfigureObjectsx/ConfigureObjectsx.cpp\
-					./ComputePressurex/ComputePressurex.h\
-					./ComputePressurex/ComputePressurex.cpp\
-					./BuildNodeSetsx/BuildNodeSetsx.h\
-					./BuildNodeSetsx/BuildNodeSetsx.cpp\
-					./BuildNodeSetsx/PartitionSets.cpp\
-					./SpcNodesx/SpcNodesx.h\
-					./SpcNodesx/SpcNodesx.cpp\
-					./MpcNodesx/MpcNodesx.h\
-					./MpcNodesx/MpcNodesx.cpp\
-					./DataInterpx/DataInterpx.cpp\
-					./DataInterpx/DataInterpx.h\
-					./HoleFillerx/HoleFillerx.cpp\
-					./HoleFillerx/HoleFillerx.h\
-					./MeshPartitionx/MeshPartitionx.cpp\
-					./MeshPartitionx/MeshPartitionx.h\
-					./ContourToMeshx/ContourToMeshx.cpp\
-					./ContourToMeshx/ContourToMeshx.h\
-					./Reducevectorgtosx/Reducevectorgtosx.cpp\
-					./Reducevectorgtosx/Reducevectorgtosx.h\
-					./Reducematrixfromgtofx/Reducematrixfromgtofx.cpp\
-					./Reducematrixfromgtofx/Reducematrixfromgton.cpp\
-					./Reducematrixfromgtofx/Reducematrixfromgtofx.h\
-					./Reduceloadfromgtofx/Reduceloadfromgtofx.h\
-					./Reduceloadfromgtofx/Reduceloadfromgtofx.cpp\
-					./NormalizeConstraintsx/NormalizeConstraintsx.cpp\
-					./NormalizeConstraintsx/NormalizeConstraintsx.h\
-					./SystemMatricesx/SystemMatricesx.cpp\
-					./SystemMatricesx/SystemMatricesx.h\
-					./PenaltyConstraintsx/PenaltyConstraintsx.cpp\
-					./PenaltyConstraintsx/PenaltyConstraintsx.h\
-					./PenaltySystemMatricesx/PenaltySystemMatricesx.cpp\
-					./PenaltySystemMatricesx/PenaltySystemMatricesx.h\
-					./Solverx/Solverx.cpp\
-					./Solverx/Solverx.h\
-					./Mergesolutionfromftogx/Mergesolutionfromftogx.cpp\
-					./Mergesolutionfromftogx/Mergesolutionfromftogx.h\
-					./ProcessParamsx/ProcessParamsx.cpp\
-					./ProcessParamsx/ProcessParamsx.h\
-					./VelocityExtrudex/VelocityExtrudex.cpp\
-					./VelocityExtrudex/VelocityExtrudex.h\
-					./SlopeExtrudex/SlopeExtrudex.cpp\
-					./SlopeExtrudex/SlopeExtrudex.h
-
-
-
-
-libISSM_a_CXXFLAGS = -fPIC -DMATLAB -D_SERIAL_ -ansi -D_GNU_SOURCE -fno-omit-frame-pointer -pthread -D_CPP_
-if LARGEARRAYS
-libISSM_a_CXXFLAGS += -D__GCC4BUILD__  
-else
-libISSM_a_CXXFLAGS += -DMX_COMPAT_32
-endif
-
-
-
-
-#Parallel compilation
-libpISSM_a_SOURCES = ./objects/objects.h\
-					./objects/Object.h\
-					./objects/Element.h\
-					./objects/Element.cpp\
-					./objects/Material.h\
-					./objects/Material.cpp\
-					./objects/Load.h\
-					./objects/Load.cpp\
-					./objects/SolverEnum.h\
-					./objects/Contour.h\
-					./objects/Contour.cpp\
-					./objects/OptArgs.h\
-					./objects/OptPars.h\
-					./objects/Friction.h\
-					./objects/Friction.cpp\
-					./objects/Node.h\
-					./objects/Node.cpp\
-					./objects/Tria.h\
-					./objects/Tria.cpp\
-					./objects/Sing.h\
-					./objects/Sing.cpp\
-					./objects/Beam.h\
-					./objects/Beam.cpp\
-					./objects/Penta.h\
-					./objects/Penta.cpp\
-					./objects/Matice.h\
-					./objects/Matice.cpp\
-					./objects/Matpar.h\
-					./objects/Matpar.cpp\
-					./objects/Input.h\
-					./objects/Input.cpp\
-					./objects/ParameterInputs.h\
-					./objects/ParameterInputs.cpp\
-					./objects/Spc.cpp\
-					./objects/Spc.h\
-					./objects/Rgb.cpp\
-					./objects/Rgb.h\
-					./objects/Penpair.cpp\
-					./objects/Penpair.h\
-					./objects/Pengrid.cpp\
-					./objects/Pengrid.h\
-					./objects/Icefront.cpp\
-					./objects/Icefront.h\
-					./objects/Param.cpp\
-					./objects/Param.h\
-					./objects/NodeSets.cpp\
-					./objects/NodeSets.h\
-					./DataSet/DataSet.cpp\
-					./DataSet/DataSet.h\
-					./shared/shared.h\
-					./shared/Alloc/alloc.h\
-					./shared/Alloc/alloc.cpp\
-					./shared/Matlab/matlabshared.h\
-					./shared/Matlab/PrintfFunction.cpp\
-					./shared/Matlab/ModuleBoot.cpp\
-					./shared/Matlab/mxGetAssignedField.cpp\
-					./shared/Matlab/mxGetField.cpp\
-					./shared/Matlab/CheckNumMatlabArguments.cpp\
-					./shared/Matrix/matrix.h\
-					./shared/Matrix/MatrixUtils.cpp\
-					./shared/Dofs/dofs.h\
-					./shared/Dofs/dofsetgen.cpp\
-					./shared/Numerics/numerics.h\
-					./shared/Numerics/GaussPoints.h\
-					./shared/Numerics/GaussPoints.cpp\
-					./shared/Numerics/cross.cpp\
-					./shared/Numerics/norm.cpp\
-					./shared/Numerics/BrentSearch.cpp\
-					./shared/Numerics/OptFunc.cpp\
-					./shared/Numerics/DistributeNumDofs.cpp\
 					./shared/Numerics/extrema.cpp\
 					./shared/Exceptions/exceptions.h\
@@ -413,7 +167,249 @@
 					./ModelProcessorx/Model.h\
 					./ModelProcessorx/Model.cpp\
-					./ModelProcessorx/CreateElementsNodesAndMaterials.cpp\
-					./ModelProcessorx/CreateConstraints.cpp \
-					./ModelProcessorx/CreateLoads.cpp\
+					./ModelProcessorx/CreateDataSets.cpp\
+					./ModelProcessorx/CreateParameters.cpp\
+					./ModelProcessorx/DiagnosticHoriz/CreateElementsNodesAndMaterialsDiagnosticHoriz.cpp\
+					./ModelProcessorx/DiagnosticHoriz/CreateConstraintsDiagnosticHoriz.cpp \
+					./ModelProcessorx/DiagnosticHoriz/CreateLoadsDiagnosticHoriz.cpp\
+					./ModelProcessorx/DiagnosticHoriz/CreateParametersDiagnosticHoriz.cpp\
+					./ModelProcessorx/DiagnosticVert/CreateElementsNodesAndMaterialsDiagnosticVert.cpp\
+					./ModelProcessorx/DiagnosticVert/CreateConstraintsDiagnosticVert.cpp \
+					./ModelProcessorx/DiagnosticVert/CreateLoadsDiagnosticVert.cpp\
+					./ModelProcessorx/DiagnosticHutter/CreateElementsNodesAndMaterialsDiagnosticHutter.cpp\
+					./ModelProcessorx/DiagnosticHutter/CreateConstraintsDiagnosticHutter.cpp \
+					./ModelProcessorx/DiagnosticHutter/CreateLoadsDiagnosticHutter.cpp\
+					./ModelProcessorx/DiagnosticStokes/CreateElementsNodesAndMaterialsDiagnosticStokes.cpp\
+					./ModelProcessorx/DiagnosticStokes/CreateConstraintsDiagnosticStokes.cpp \
+					./ModelProcessorx/DiagnosticStokes/CreateLoadsDiagnosticStokes.cpp\
+					./ModelProcessorx/SlopeCompute/CreateElementsNodesAndMaterialsSlopeCompute.cpp\
+					./ModelProcessorx/SlopeCompute/CreateConstraintsSlopeCompute.cpp \
+					./ModelProcessorx/SlopeCompute/CreateLoadsSlopeCompute.cpp\
+					./ModelProcessorx/Control/CreateParametersControl.cpp\
+					./Dofx/Dofx.h\
+					./Dofx/Dofx.cpp\
+					./Dux/Dux.h\
+					./Dux/Dux.cpp\
+					./GriddataMeshToGridx/GriddataMeshToGridx.h\
+					./GriddataMeshToGridx/GriddataMeshToGridx.cpp\
+					./ControlConstrainx/ControlConstrainx.h\
+					./ControlConstrainx/ControlConstrainx.cpp\
+					./Misfitx/Misfitx.h\
+					./Misfitx/Misfitx.cpp\
+					./Orthx/Orthx.h\
+					./Orthx/Orthx.cpp\
+					./Gradjx/Gradjx.h\
+					./Gradjx/Gradjx.cpp\
+					./UpdateFromInputsx/UpdateFromInputsx.h\
+					./UpdateFromInputsx/UpdateFromInputsx.cpp\
+					./ConfigureObjectsx/ConfigureObjectsx.h\
+					./ConfigureObjectsx/ConfigureObjectsx.cpp\
+					./ComputePressurex/ComputePressurex.h\
+					./ComputePressurex/ComputePressurex.cpp\
+					./BuildNodeSetsx/BuildNodeSetsx.h\
+					./BuildNodeSetsx/BuildNodeSetsx.cpp\
+					./BuildNodeSetsx/PartitionSets.cpp\
+					./SpcNodesx/SpcNodesx.h\
+					./SpcNodesx/SpcNodesx.cpp\
+					./MpcNodesx/MpcNodesx.h\
+					./MpcNodesx/MpcNodesx.cpp\
+					./DataInterpx/DataInterpx.cpp\
+					./DataInterpx/DataInterpx.h\
+					./HoleFillerx/HoleFillerx.cpp\
+					./HoleFillerx/HoleFillerx.h\
+					./MeshPartitionx/MeshPartitionx.cpp\
+					./MeshPartitionx/MeshPartitionx.h\
+					./ContourToMeshx/ContourToMeshx.cpp\
+					./ContourToMeshx/ContourToMeshx.h\
+					./Reducevectorgtosx/Reducevectorgtosx.cpp\
+					./Reducevectorgtosx/Reducevectorgtosx.h\
+					./Reducematrixfromgtofx/Reducematrixfromgtofx.cpp\
+					./Reducematrixfromgtofx/Reducematrixfromgton.cpp\
+					./Reducematrixfromgtofx/Reducematrixfromgtofx.h\
+					./Reduceloadfromgtofx/Reduceloadfromgtofx.h\
+					./Reduceloadfromgtofx/Reduceloadfromgtofx.cpp\
+					./NormalizeConstraintsx/NormalizeConstraintsx.cpp\
+					./NormalizeConstraintsx/NormalizeConstraintsx.h\
+					./SystemMatricesx/SystemMatricesx.cpp\
+					./SystemMatricesx/SystemMatricesx.h\
+					./PenaltyConstraintsx/PenaltyConstraintsx.cpp\
+					./PenaltyConstraintsx/PenaltyConstraintsx.h\
+					./PenaltySystemMatricesx/PenaltySystemMatricesx.cpp\
+					./PenaltySystemMatricesx/PenaltySystemMatricesx.h\
+					./Solverx/Solverx.cpp\
+					./Solverx/Solverx.h\
+					./Mergesolutionfromftogx/Mergesolutionfromftogx.cpp\
+					./Mergesolutionfromftogx/Mergesolutionfromftogx.h\
+					./ProcessParamsx/ProcessParamsx.cpp\
+					./ProcessParamsx/ProcessParamsx.h\
+					./VelocityExtrudex/VelocityExtrudex.cpp\
+					./VelocityExtrudex/VelocityExtrudex.h\
+					./SlopeExtrudex/SlopeExtrudex.cpp\
+					./SlopeExtrudex/SlopeExtrudex.h
+
+
+
+
+libISSM_a_CXXFLAGS = -fPIC -DMATLAB -D_SERIAL_ -ansi -D_GNU_SOURCE -fno-omit-frame-pointer -pthread -D_CPP_
+if LARGEARRAYS
+libISSM_a_CXXFLAGS += -D__GCC4BUILD__  
+else
+libISSM_a_CXXFLAGS += -DMX_COMPAT_32
+endif
+
+
+
+
+#Parallel compilation
+libpISSM_a_SOURCES = ./objects/objects.h\
+					./objects/Object.h\
+					./objects/Element.h\
+					./objects/Element.cpp\
+					./objects/Material.h\
+					./objects/Material.cpp\
+					./objects/Load.h\
+					./objects/Load.cpp\
+					./objects/SolverEnum.h\
+					./objects/Contour.h\
+					./objects/Contour.cpp\
+					./objects/OptArgs.h\
+					./objects/OptPars.h\
+					./objects/Friction.h\
+					./objects/Friction.cpp\
+					./objects/Node.h\
+					./objects/Node.cpp\
+					./objects/Tria.h\
+					./objects/Tria.cpp\
+					./objects/Sing.h\
+					./objects/Sing.cpp\
+					./objects/Beam.h\
+					./objects/Beam.cpp\
+					./objects/Penta.h\
+					./objects/Penta.cpp\
+					./objects/Matice.h\
+					./objects/Matice.cpp\
+					./objects/Matpar.h\
+					./objects/Matpar.cpp\
+					./objects/Input.h\
+					./objects/Input.cpp\
+					./objects/ParameterInputs.h\
+					./objects/ParameterInputs.cpp\
+					./objects/Spc.cpp\
+					./objects/Spc.h\
+					./objects/Rgb.cpp\
+					./objects/Rgb.h\
+					./objects/Penpair.cpp\
+					./objects/Penpair.h\
+					./objects/Pengrid.cpp\
+					./objects/Pengrid.h\
+					./objects/Icefront.cpp\
+					./objects/Icefront.h\
+					./objects/Param.cpp\
+					./objects/Param.h\
+					./objects/NodeSets.cpp\
+					./objects/NodeSets.h\
+					./DataSet/DataSet.cpp\
+					./DataSet/DataSet.h\
+					./shared/shared.h\
+					./shared/Alloc/alloc.h\
+					./shared/Alloc/alloc.cpp\
+					./shared/Matlab/matlabshared.h\
+					./shared/Matlab/PrintfFunction.cpp\
+					./shared/Matlab/ModuleBoot.cpp\
+					./shared/Matlab/mxGetAssignedField.cpp\
+					./shared/Matlab/mxGetField.cpp\
+					./shared/Matlab/CheckNumMatlabArguments.cpp\
+					./shared/Matrix/matrix.h\
+					./shared/Matrix/MatrixUtils.cpp\
+					./shared/Dofs/dofs.h\
+					./shared/Dofs/dofsetgen.cpp\
+					./shared/Dofs/DistributeNumDofs.cpp\
+					./shared/Numerics/numerics.h\
+					./shared/Numerics/GaussPoints.h\
+					./shared/Numerics/GaussPoints.cpp\
+					./shared/Numerics/cross.cpp\
+					./shared/Numerics/norm.cpp\
+					./shared/Numerics/BrentSearch.cpp\
+					./shared/Numerics/OptFunc.cpp\
+					./shared/Numerics/extrema.cpp\
+					./shared/Exceptions/exceptions.h\
+					./shared/Exceptions/Exceptions.cpp\
+					./shared/Exceptions/exprintf.cpp\
+					./shared/Exp/exp.h\
+					./shared/Exp/IsInPoly.cpp\
+					./shared/Exp/IsInPolySerial.cpp\
+					./shared/Exp/DomainOutlineRead.cpp\
+					./shared/TriMesh/trimesh.h\
+					./shared/TriMesh/AssociateSegmentToElement.cpp\
+					./shared/TriMesh/GridInsideHole.cpp\
+					./shared/TriMesh/OrderSegments.cpp\
+					./shared/TriMesh/SplitMeshForRifts.cpp\
+					./shared/TriMesh/TriMeshUtils.cpp\
+					./shared/Sorting/binary_search.cpp\
+					./shared/Sorting/sorting.h\
+					./shared/Elements/elements.h\
+					./shared/Elements/ResolvePointers.cpp\
+					./shared/Elements/Paterson.cpp\
+					./shared/Elements/GetElementNodeData.cpp\
+					./toolkits/petsc\
+					./toolkits/petsc/patches\
+					./toolkits/petsc/patches/petscpatches.h\
+					./toolkits/petsc/patches/MatlabMatrixToPetscMatrix.cpp\
+					./toolkits/petsc/patches/MatlabVectorToPetscVector.cpp\
+					./toolkits/petsc/patches/PetscMatrixToMatlabMatrix.cpp\
+					./toolkits/petsc/patches/PetscVectorToMatlabVector.cpp\
+					./toolkits/petsc/patches/MatlabMatrixToDoubleMatrix.cpp\
+					./toolkits/petsc/patches/MatlabVectorToDoubleVector.cpp\
+					./toolkits/petsc/patches/PetscDetermineLocalSize.cpp\
+					./toolkits/petsc/patches/VecTranspose.cpp\
+					./toolkits/petsc/patches/VecToMPISerial.cpp\
+					./toolkits/petsc/patches/MatToSerial.cpp\
+					./toolkits/petsc/patches/VecMerge.cpp\
+					./toolkits/petsc/patches/NewVec.cpp\
+					./toolkits/petsc/patches/NewVecFromLocalSize.cpp\
+					./toolkits/petsc/patches/PetscOptionsDetermineSolverType.cpp\
+					./toolkits/petsc/patches/PetscOptionsInsertMultipleString.cpp\
+					./toolkits/petsc/patches/NewMat.cpp\
+					./toolkits/petsc/patches/VecFree.cpp\
+					./toolkits/petsc/patches/VecDuplicatePatch.cpp\
+					./toolkits/petsc/patches/KSPFree.cpp\
+					./toolkits/petsc/patches/ISFree.cpp\
+					./toolkits/petsc/patches/MatFree.cpp\
+					./toolkits/petsc/patches/GetOwnershipBoundariesFromRange.cpp\
+					./toolkits/petsc/patches/VecPartition.cpp\
+					./toolkits/petsc/patches/MatPartition.cpp\
+					./toolkits/petsc/patches/MatInvert.cpp\
+					./toolkits/petsc/patches/MatMultPatch.cpp\
+					./toolkits/petsc/petscincludes.h\
+					./toolkits/mpi/mpiincludes.h\
+					./toolkits/mpi/patches/mpipatches.h\
+					./toolkits/mpi/patches/MPI_Upperrow.cpp\
+					./toolkits/mpi/patches/MPI_Lowerrow.cpp\
+					./toolkits/mpi/patches/MPI_Boundariesfromrange.cpp\
+					./toolkits/metis/metisincludes.h\
+					./toolkits/triangle/triangleincludes.h\
+					./toolkits.h\
+					./io/io.h\
+					./io/FetchData.cpp\
+					./io/WriteData.cpp\
+					./io/WriteDataToDisk.cpp\
+					./io/SerialFetchData.cpp\
+					./io/SerialWriteData.cpp\
+					./io/ParallelFetchData.cpp\
+					./io/ParallelFetchInteger.cpp\
+					./io/ParallelFetchMat.cpp\
+					./io/ParallelFetchScalar.cpp\
+					./io/ParallelFetchString.cpp\
+					./io/ModelFetchData.cpp\
+					./io/WriteNodeSets.cpp\
+					./io/WriteParams.cpp\
+					./io/FetchNodeSets.cpp\
+					./io/FetchRifts.cpp\
+					./io/ParameterInputsInit.cpp\
+					./EnumDefinitions/EnumDefinitions.h\
+					./EnumDefinitions/EnumDefinitions.cpp\
+					./EnumDefinitions/AnalysisTypeAsEnum.cpp\
+					./ModelProcessorx/Model.h\
+					./ModelProcessorx/Model.cpp\
+					./ModelProcessorx/CreateDataSets.cpp\
 					./ModelProcessorx/CreateParameters.cpp\
 					./ModelProcessorx/DiagnosticHoriz/CreateElementsNodesAndMaterialsDiagnosticHoriz.cpp\
@@ -510,6 +506,5 @@
 bin_PROGRAMS = 
 else 
-bin_PROGRAMS = diagnostic.exe control.exe 
-#thermalsteady.exe
+bin_PROGRAMS = diagnostic.exe control.exe thermal.exe
 endif
 
@@ -522,4 +517,4 @@
 control_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
 
-thermalsteady_exe_SOURCES = parallel/thermalsteady.cpp
-thermalsteady_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
+thermal_exe_SOURCES = parallel/thermal.cpp
+thermal_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
Index: issm/trunk/src/c/Misfitx/Misfitx.cpp
===================================================================
--- issm/trunk/src/c/Misfitx/Misfitx.cpp	(revision 464)
+++ issm/trunk/src/c/Misfitx/Misfitx.cpp	(revision 465)
@@ -14,5 +14,5 @@
 
 void Misfitx( double* pJ, DataSet* elements,DataSet* nodes, DataSet* loads, DataSet* materials, 
-		double* u_g, double* u_g_obs, ParameterInputs* inputs,int analysis_type){
+		double* u_g, double* u_g_obs, ParameterInputs* inputs,int analysis_type,int sub_analysis_type){
 	
 	/*output: */
@@ -24,5 +24,5 @@
 
 	/*Compute gradients: */
-	elements->Misfit(&J, u_g,u_g_obs,inputs,analysis_type);
+	elements->Misfit(&J, u_g,u_g_obs,inputs,analysis_type,sub_analysis_type);
 
 	/*Sum all J from all cpus of the cluster:*/
Index: issm/trunk/src/c/Misfitx/Misfitx.h
===================================================================
--- issm/trunk/src/c/Misfitx/Misfitx.h	(revision 464)
+++ issm/trunk/src/c/Misfitx/Misfitx.h	(revision 465)
@@ -10,5 +10,5 @@
 /* local prototypes: */
 void Misfitx( double* pJ, DataSet* elements,DataSet* nodes, DataSet* loads, DataSet* materials, 
-		double* u_g, double* u_g_obs, ParameterInputs* inputs,int analysis_type);
+		double* u_g, double* u_g_obs, ParameterInputs* inputs,int analysis_type,int sub_analysis_type);
 
 #endif  /* _MISFITX_H */
Index: issm/trunk/src/c/ModelProcessorx/Control/CreateParametersControl.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/Control/CreateParametersControl.cpp	(revision 464)
+++ issm/trunk/src/c/ModelProcessorx/Control/CreateParametersControl.cpp	(revision 465)
@@ -13,8 +13,9 @@
 #include "../Model.h"
 
-void CreateParametersControl(DataSet* parameters,Model* model,ConstDataHandle model_handle,int* pcount){
+void CreateParametersControl(DataSet** pparameters,Model* model,ConstDataHandle model_handle){
 	
 	int i;
 	
+	DataSet* parameters=NULL;
 	Param*   param = NULL;
 	int      count;
@@ -29,6 +30,7 @@
 	double* vy_obs=NULL;
 
-	/*Get counter : */
-	count=*pcount;
+	/*Get parameters: */
+	parameters=*pparameters;
+	count=parameters->Size();
 	
 	/*control_type: */
@@ -132,5 +134,5 @@
 
 	/*Assign output pointer: */
-	*pcount=count;
+	*pparameters=parameters;
 }
 
Index: issm/trunk/src/c/ModelProcessorx/CreateDataSets.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/CreateDataSets.cpp	(revision 465)
+++ issm/trunk/src/c/ModelProcessorx/CreateDataSets.cpp	(revision 465)
@@ -0,0 +1,104 @@
+/*!\file: CreateDataSets
+ * \brief general driver for creating all datasets that make a finite element model
+ */ 
+
+#ifdef HAVE_CONFIG_H
+	#include "config.h"
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#undef __FUNCT__ 
+#define __FUNCT__ "CreateElementsNodesAndMaterials"
+
+#include "./Model.h"
+#include "../shared/shared.h"
+
+
+void CreateDataSets(DataSet** pelements,DataSet** pnodes, DataSet** pmaterials, DataSet** pconstraints, DataSet** ploads,DataSet** pparameters,Model* model,ConstDataHandle model_handle){
+
+
+	/*create parameters common to all solutions: */
+	CreateParameters(pparameters,model,model_handle);
+
+	/*This is just a high level driver: */
+	if (strcmp(model->analysis_type,"control")==0){
+
+		CreateElementsNodesAndMaterialsDiagnosticHoriz(pelements,pnodes,pmaterials, model,model_handle);
+		CreateConstraintsDiagnosticHoriz(pconstraints,model,model_handle);
+		CreateLoadsDiagnosticHoriz(ploads,model,model_handle);
+		CreateParametersControl(pparameters,model,model_handle);
+					
+	}
+	else if (strcmp(model->analysis_type,"diagnostic")==0){
+
+		if (strcmp(model->sub_analysis_type,"horiz")==0){
+			
+			CreateElementsNodesAndMaterialsDiagnosticHoriz(pelements,pnodes,pmaterials, model,model_handle);
+			CreateConstraintsDiagnosticHoriz(pconstraints,model,model_handle);
+			CreateLoadsDiagnosticHoriz(ploads,model,model_handle);
+			CreateParametersDiagnosticHoriz(pparameters,model,model_handle);
+				
+		}
+		else if (strcmp(model->sub_analysis_type,"vert")==0){
+		
+			CreateElementsNodesAndMaterialsDiagnosticVert(pelements,pnodes,pmaterials, model,model_handle);
+			CreateConstraintsDiagnosticVert(pconstraints,model,model_handle);
+			CreateLoadsDiagnosticVert(ploads,model,model_handle);
+			
+		}
+		else if (strcmp(model->sub_analysis_type,"stokes")==0){
+
+			CreateElementsNodesAndMaterialsDiagnosticStokes(pelements,pnodes,pmaterials, model,model_handle);
+			CreateConstraintsDiagnosticStokes(pconstraints,model,model_handle);
+			CreateLoadsDiagnosticStokes(ploads,model,model_handle);
+			
+		}
+		else if (strcmp(model->sub_analysis_type,"hutter")==0){
+
+			CreateElementsNodesAndMaterialsDiagnosticHutter(pelements,pnodes,pmaterials, model,model_handle);
+			CreateConstraintsDiagnosticHutter(pconstraints,model,model_handle);
+			CreateLoadsDiagnosticHutter(ploads,model,model_handle);
+			
+		}
+	}
+	else if (strcmp(model->analysis_type,"slope_compute")==0){
+
+		CreateElementsNodesAndMaterialsSlopeCompute(pelements,pnodes,pmaterials, model,model_handle);
+		CreateConstraintsSlopeCompute(pconstraints,model,model_handle);
+		CreateLoadsSlopeCompute(ploads,model,model_handle);
+			
+	
+	}
+	else if (strcmp(model->analysis_type,"thermal")==0){
+
+		if ((strcmp(model->sub_analysis_type,"steady")==0) || (strcmp(model->sub_analysis_type,"transient")==0)){
+		
+			//CreateElementsNodesAndMaterialsThermal(pelements,pnodes,pmaterials, model,model_handle);
+			//CreateConstraintsThermal(pconstraints,model,model_handle);
+			//CreateLoadsThermal(ploads,model,model_handle);
+					
+		}
+		else if (strcmp(model->sub_analysis_type,"melting")==0){
+			
+			//CreateElementsNodesAndMaterialsMelting(pelements,pnodes,pmaterials, model,model_handle);
+			//CreateConstraintsMelting(pconstraints,model,model_handle);
+			//CreateLoadsMelting(ploads,model,model_handle);
+
+		}
+	}
+	else if (strcmp(model->analysis_type,"prognostic")==0){
+			
+		//CreateElementsNodesAndMaterialsPrognostic(pelements,pnodes,pmaterials, model,model_handle);
+		//CreateConstraintsPrognostic(pconstraints,model,model_handle);
+		//CreateLoadsPrognostic(ploads,model,model_handle);
+	}
+	else{
+		throw ErrorException(__FUNCT__,exprintf("%s%s%s%s"," analysis_type: ",model->analysis_type," sub_analysis_type: ",model->sub_analysis_type," not supported yet!"));
+	}
+
+
+
+
+
+}
Index: issm/trunk/src/c/ModelProcessorx/CreateParameters.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/CreateParameters.cpp	(revision 464)
+++ issm/trunk/src/c/ModelProcessorx/CreateParameters.cpp	(revision 465)
@@ -21,4 +21,5 @@
 	int      count=1;
 	int      analysis_type;
+	int      sub_analysis_type;
 	int      numberofdofspernode;
 	int      dim;
@@ -29,8 +30,14 @@
 	//Get analysis_type:
 	analysis_type=AnalysisTypeAsEnum(model->analysis_type);
+	sub_analysis_type=AnalysisTypeAsEnum(model->sub_analysis_type);
 	
 	count++;
 	param= new Param(count,"analysis_type",INTEGER);
 	param->SetInteger(analysis_type);
+	parameters->AddObject(param);
+
+	count++;
+	param= new Param(count,"sub_analysis_type",INTEGER);
+	param->SetInteger(sub_analysis_type);
 	parameters->AddObject(param);
 
@@ -187,5 +194,5 @@
 
 	/*Deal with numberofdofspernode: */
-	DistributeNumDofs(&numberofdofspernode,analysis_type);
+	DistributeNumDofs(&numberofdofspernode,analysis_type,sub_analysis_type);
 
 	count++;
@@ -194,11 +201,4 @@
 	parameters->AddObject(param);
 
-	/*Deal with control parameters: */
-	if (analysis_type==ControlAnalysisEnum()){
-		CreateParametersControl(parameters,model,model_handle,&count);
-	}
-	if (analysis_type==DiagnosticHorizAnalysisEnum()){
-		CreateParametersDiagnosticHoriz(parameters,model,model_handle,&count);
-	}
 
 	
Index: issm/trunk/src/c/ModelProcessorx/DiagnosticHoriz/CreateElementsNodesAndMaterialsDiagnosticHoriz.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/DiagnosticHoriz/CreateElementsNodesAndMaterialsDiagnosticHoriz.cpp	(revision 464)
+++ issm/trunk/src/c/ModelProcessorx/DiagnosticHoriz/CreateElementsNodesAndMaterialsDiagnosticHoriz.cpp	(revision 465)
@@ -38,4 +38,5 @@
 
 	int         analysis_type;
+	int         sub_analysis_type;
 	
 	/*output: */
@@ -154,4 +155,5 @@
 	/*Get analysis_type: */
 	analysis_type=AnalysisTypeAsEnum(model->analysis_type);
+	sub_analysis_type=AnalysisTypeAsEnum(model->sub_analysis_type);
 
 	
@@ -571,5 +573,5 @@
 
 	/*Get number of dofs per node: */
-	DistributeNumDofs(&node_numdofs,analysis_type);
+	DistributeNumDofs(&node_numdofs,analysis_type,sub_analysis_type);
 
 	for (i=0;i<model->numberofnodes;i++){
Index: issm/trunk/src/c/ModelProcessorx/DiagnosticHoriz/CreateParametersDiagnosticHoriz.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/DiagnosticHoriz/CreateParametersDiagnosticHoriz.cpp	(revision 464)
+++ issm/trunk/src/c/ModelProcessorx/DiagnosticHoriz/CreateParametersDiagnosticHoriz.cpp	(revision 465)
@@ -13,7 +13,8 @@
 #include "../Model.h"
 
-void CreateParametersDiagnosticHoriz(DataSet* parameters,Model* model,ConstDataHandle model_handle,int* pcount){
+void CreateParametersDiagnosticHoriz(DataSet** pparameters,Model* model,ConstDataHandle model_handle){
 	
 	Param*   param = NULL;
+	DataSet* parameters=NULL;
 	int      count;
 	int i;
@@ -23,9 +24,11 @@
 	double* vz=NULL;
 
+	/*recover parameters : */
+	parameters=*pparameters;
+
+	count=parameters->Size();
+
 	/*Now, is the flag macayaealpattyn on? otherwise, do nothing: */
 	if (!model->ismacayealpattyn)return;
-
-	/*Get counter : */
-	count=*pcount;
 
 	/*Get vx and vy: */
@@ -61,5 +64,5 @@
 	
 	/*Assign output pointer: */
-	*pcount=count;
+	*pparameters=parameters;
 }
 
Index: issm/trunk/src/c/ModelProcessorx/DiagnosticHutter/CreateElementsNodesAndMaterialsDiagnosticHutter.cpp
===================================================================
--- issm/trunk/src/c/ModelProcessorx/DiagnosticHutter/CreateElementsNodesAndMaterialsDiagnosticHutter.cpp	(revision 464)
+++ issm/trunk/src/c/ModelProcessorx/DiagnosticHutter/CreateElementsNodesAndMaterialsDiagnosticHutter.cpp	(revision 465)
@@ -40,4 +40,5 @@
 
 	int         analysis_type;
+	int         sub_analysis_type;
 	
 	/*output: */
@@ -106,4 +107,5 @@
 	/*Get analysis_type: */
 	analysis_type=AnalysisTypeAsEnum(model->analysis_type);
+	sub_analysis_type=AnalysisTypeAsEnum(model->sub_analysis_type);
 
 	/*Width of elements: */
@@ -297,5 +299,5 @@
 	
 	/*Get number of dofs per node: */
-	DistributeNumDofs(&node_numdofs,analysis_type);
+	DistributeNumDofs(&node_numdofs,analysis_type,sub_analysis_type);
 
 	for (i=0;i<model->numberofnodes;i++){
